require_relative 'codebreaker_vukolov_edition'

module CodebreakerVukolovEdition
  class Messages
    INFO_MESSAGES = {
      new_game: '(?) Would you like to play new game? [yes/no]',
      save_result: '(?) Would you like to save result of your game? [yes/no]',
      input: '> Please provide your guess',
      input_warning: "(!) The input should be exactly four digits or 'hint' word",
      name: 'What is your name?',
      instruction: "(!) Please follow to instruction. You can type only 'yes' or 'no'",
      result_saved: 'Result of your game was written to file: ',
      game_unsaved: 'Ok, nobody will know about your fail LoL, azaza!!!!!!!11)',
      round_result: 'Your result is: '
    }

    def before_round_info(turns)
      puts "====================== round ##{turns + 1} ======================
      You have #{CodebreakerVukolovEdition::Game::MAX_TURNS - turns} turns for breaking this code"
    end

    def print_hint(hint)
      puts "HINT: #{hint[:value]}"
    end

    def hint_info
      puts "(*) Also, you can use hint (the system reveals one of the numbers in the secret code). If you need a hint, please put 'hint'"
    end

    def total_game_info(state, turns, secret_code)
      case state
      when :won
        puts "
        Congratulation!!!!
        You have hacked this code by #{turns} turns, the code is #{secret_code.join('')}"
      when :lose
        puts "Unfortunately you spent all your turns (#{turns}) and didn't brake the code. Code was #{secret_code.join('')}"
      end
    end

    def show_messages(symbol, *arg)
      message = arg.empty? ? INFO_MESSAGES[symbol] : INFO_MESSAGES[symbol] + arg.first
      puts message
    end
  end
end
