require 'yaml'

module CodebreakerVukolovEdition
  class Saves
    FILENAME = 'results.yml'
    attr_accessor :time, :username, :state, :turns, :hint, :secret_code

    def initialize(username, state, game)
      @time = Time.now.strftime('%F %T')
      @username = username
      @state = state
      @turns = game.turns
      @hint = game.hint
      @secret_code = game.secret_code
    end

    def write_to_file
      db = open_database
      new_save = db.push(self)
      File.open(FILENAME, 'w') {|f| f.write new_save.to_yaml }
    end

    def open_database
      return File.open(FILENAME, 'a') {|f| f.write Array.new.to_yaml } unless File.exist?(FILENAME)
      YAML::load_file(FILENAME)
    end
  end
end
